import math,sys,os

import globs
from globs import *


class _Spritez:
    def __init__(self):
        self.framechoords = []
        self.frame        = 0
        self.frames       = []
        self.fps          = 15
        self.lastupdated  = 0.0

        #just for some debugging
        self.exceptiontest = 0 ##remove once fixed
        self.before_hit    = None
        self.before_direction = None
        
        
    def getframes(self,imagesheet):
        images = {}
        for i,ele in enumerate(self.framechoords):
            image = pygame.Surface((50,50)).convert_alpha()
            image.fill((0,0,0,0))
            image.blit(imagesheet,(0,0),(50*ele[0],50*ele[1],50,50))
            images[i] = image
        return images
    
class Projectile(_Spritez):
    def __init__(self,direction,startrect):
        """Duration should be given in seconds, and location is a rect"""
        _Spritez.__init__(self)
        self.fps       = 7
        self.rect      = pygame.Rect(0,0,50,50)
        self.direction = direction
        self.mask      = ((50,50))
        self.range = 10
        self.speed = 3
        self.last_updated = 0.0
        self.startrect = startrect
        self.get_range()

        self.atk = 1 #default damage of a standard projectile

        self.done = False #changes to true when the projectile is finished

    def get_range(self):
        self.pic = 0
        self.pics = int((self.range*50)/self.speed)
        self.extra = (self.range*50) - (self.pics*self.speed)

        globs.Level.objects["projectiles"].append(self)

    def shoot(self):
        self.image = pygame.Surface((50,50)).convert_alpha()
        self.image.fill((0,0,0,0))
        if self.pic < self.pics:
                if   self.direction == "right":
                    if self.startrect.x < 900:
                        self.rect.topleft = (self.startrect.right+self.pic*self.speed,self.startrect.y)
                        if self.rect.x  <  950:
                            self.image.blit(self.frames[self.frame],(0,0))
                        else:
                            self.rect.x -= self.speed
##                            self.pic     = self.pics
                            self.done    = True
                    else: self.done    = True
                elif self.direction == "left":
                    if self.startrect.x >= 100: 
                        self.rect.x,self.rect.y = self.startrect.x-50-self.pic*self.speed,self.startrect.y
                        if self.rect.x  >    0:
                            self.image.blit(pygame.transform.flip(self.frames[self.frame],True,False),(0,0))
                        else:
                            self.rect.x += self.speed
##                            self.pic     = self.pics
                            self.done    = True
                    else: self.done    = True
                if self.direction == "back":
                    if self.startrect.y >= 100:
                        self.rect.x,self.rect.y = self.startrect.x,self.startrect.y-50-self.pic*self.speed
                        if self.rect.y  >    0:
                            self.image.blit(pygame.transform.rotate(self.frames[self.frame],90),(0,0))
                        else:
                            self.rect.y += self.speed
##                            self.pic     = self.pics
                            self.done    = True
                    else: self.done    = True
                if self.direction == "front":
                    if self.startrect.y < 600:                        
                        self.rect.topleft = self.startrect.x,self.startrect.bottom+self.pic*self.speed
                        if self.rect.y  <  650:
                            self.image.blit(pygame.transform.rotate(self.frames[self.frame],-90),(0,0))
                        else:
                            self.rect.y -= self.speed
##                            self.pic     = self.pics
                            self.done    = True
                    else:
                        self.done    = True
                self.pic += 1
        else:
            self.done = True

    def update(self):   
        self.shoot()
        globs.Surface.blit(self.image,(self.rect))
        if globs.Player.dead == True:
            self.done = True
        if self.done == True:
            globs.Level.objects["projectiles"].remove(self)

    def player_collission(self):
        self.done = True
        def collision_differential():
            #calculates a differential for the colliding rectangles in the x and y axis to determine from what direction
            #a player is hit
            dx = (globs.Player.exact_mask.overlap_area(self.mask,(-globs.Player.rect.x+self.rect.x+1,-globs.Player.rect.y+self.rect.y)) -
                  globs.Player.exact_mask.overlap_area(self.mask,(-globs.Player.rect.x+self.rect.x-1,-globs.Player.rect.y+self.rect.y)))

            dy = (globs.Player.exact_mask.overlap_area(self.mask,(-globs.Player.rect.x+self.rect.x,-globs.Player.rect.y+self.rect.y+1)) -
                  globs.Player.exact_mask.overlap_area(self.mask,(-globs.Player.rect.x+self.rect.x,-globs.Player.rect.y+self.rect.y-1)))

##            dx = (globs.Player.fatmask.overlap_area(self.mask,(-globs.Player.rect.x+self.rect.x+1,-globs.Player.rect.y+self.rect.y)) -
##                  globs.Player.fatmask.overlap_area(self.mask,(-globs.Player.rect.x+self.rect.x-1,-globs.Player.rect.y+self.rect.y)))
##
##            dy = (globs.Player.fatmask.overlap_area(self.mask,(-globs.Player.rect.x+self.rect.x,-globs.Player.rect.y+self.rect.y+1)) -
##                  globs.Player.fatmask.overlap_area(self.mask,(-globs.Player.rect.x+self.rect.x,-globs.Player.rect.y+self.rect.y-1)))
    
            if abs(dx) > abs(dy):
                if dx > 0: knock = (1,0);  #print ("knocked right")
                else     : knock = (-1,0); #print ("knocked left")
            else:
                if dy > 0: knock = (0,1);  #print ("knocked down")
                else     : knock = (0,-1); #print ("knocked up, and he didn't even buy me dinner")

##            print(dx,dy,knock)
            return knock
        
        if pygame.time.get_ticks()-globs.Player.invincible_timer > 1000:
            #damage is reduced by defense but currently can not be reduced below 1
            if self.atk - globs.Player.defense > 1:
                globs.Player.health -= (self.atk - globs.Player.defense)
            else:
                globs.Player.health -= 1
            globs.Player.knockback = True
            globs.Player.knockdir  = collision_differential()
            globs.Player.invincible_timer = pygame.time.get_ticks()
        if globs.Player.health <= 0: globs.Player.dead = True
        


class Web(Projectile):
    def __init__(self,direction,startrect):
        Projectile.__init__(self,direction,startrect)
        
        self.framechoords = [(1,0)]
        self.frames       = self.getframes(graphic["shootsheet"])
        for cell in self.frames:
            self.frames[cell] = self.frames[cell].convert()
            self.frames[cell].set_colorkey((255,0,255))
        self.mask         = pygame.mask.from_surface(self.frames[0])

        self.reallydone = False
        self.range = 3
        self.speed = 2
        self.get_range()

        self.atk = 5

    def retract(self):
        self.image = pygame.Surface((50,50)).convert_alpha()
        self.image.fill((0,0,0,0))
        if self.pic >= 0:
                if   self.direction == "right":
                    if self.startrect.x <= 900:
                        self.rect.topleft = (self.startrect.right+self.pic*self.speed,self.startrect.y)
                        self.image.blit(self.frames[self.frame],(0,0))
                    else: self.reallydone= True
                elif self.direction == "left":
                    if self.startrect.x >= 100: 
                        self.rect.x,self.rect.y = self.startrect.x-50-self.pic*self.speed,self.startrect.y
                        self.image.blit(pygame.transform.flip(self.frames[self.frame],True,False),(0,0))
                    else: self.reallydone    = True
                if self.direction == "back":
                    if self.startrect.y >= 100:
                        self.rect.x,self.rect.y = self.startrect.x,self.startrect.y-50-self.pic*self.speed
                        self.image.blit(pygame.transform.rotate(self.frames[self.frame],90),(0,0))      
                    else: self.reallydone    = True
                if self.direction == "front":
                    if self.startrect.y <= 600:                        
                        self.rect.topleft = self.startrect.x,self.startrect.bottom+self.pic*self.speed
                        self.image.blit(pygame.transform.rotate(self.frames[self.frame],-90),(0,0))  
                    else:
                        self.reallydone    = True
                self.pic -= 1
        else:
            self.reallydone = True

            
    def update(self):
        if not self.done:
            self.shoot()
        else:
            self.retract()
        if   self.direction == "right":
            globs.Surface.fill((255,255,255),(self.startrect.right,self.startrect.y+24,self.rect.x-self.startrect.right,2))
            globs.Surface.blit(self.image,self.rect)
        elif self.direction == "left":
            globs.Surface.fill((255,255,255),(self.rect.right,self.startrect.y+24,self.startrect.x-self.rect.right,2))
            globs.Surface.blit(self.image,self.rect)
        elif self.direction == "back":
            globs.Surface.fill((255,255,255),(self.startrect.x+24,self.rect.bottom,2,self.startrect.y-self.rect.bottom))
            globs.Surface.blit(self.image,self.rect)
        elif self.direction == "front":
            globs.Surface.fill((255,255,255),(self.startrect.x+24,self.startrect.bottom,2,self.rect.y-self.startrect.bottom))
            globs.Surface.blit(self.image,self.rect)

        if self.reallydone == True:
            globs.Level.objects["projectiles"].remove(self)
        


class Laser(Projectile):
    def __init__(self,direction,startrect):
        Projectile.__init__(self,direction,startrect)

        self.framechoords = [(2,0),(3,0),(4,0)]
        self.frames       = self.getframes(graphic["shootsheet"])

        mysurf = pygame.Surface((150,50)).convert()
        for cell in self.frames:
            mysurf.blit(self.frames[cell],(cell*50,0))
        mysurf.set_colorkey((255,0,255))
        
        self.total_image = mysurf
  
        self.mask = pygame.mask.from_surface(self.total_image)   ###

        self.reallydone = False
        self.range = 3
        self.speed = 2
        self.remainder = 0.0
        self.get_range()

        self.atk = 8

    def shoot(self):
        if self.direction == "right" or self.direction == "left":
            self.image = pygame.Surface((150,50)).convert_alpha()
        elif self.direction == "back" or self.direction == "front":
            self.image = pygame.Surface((50,150)).convert_alpha()
        self.image.fill((0,0,0,0))
        if self.pic < self.pics:
                if   self.direction == "right":
                    if self.startrect.x < 950:
                        self.rect = pygame.Rect(0,0,self.pic*self.speed,50)
                        if self.startrect.right+self.pic*self.speed < 1000:
                            self.image.blit(self.total_image,(0,-18),(150-self.rect.width,self.rect.y,self.rect.width,50))#self.rect)
                            self.rect.topleft = (self.startrect.right,self.startrect.y) ###
                            self.mask = pygame.mask.from_surface(self.image)   ###
                        else:
                            self.rect.width -= self.speed
                            self.done    = True
                    else: self.done    = True
                    
                elif self.direction == "left":
                    if self.startrect.x >= 50:
                        self.rect = pygame.Rect(0,0,self.pic*self.speed,50)
                        if self.startrect.x - self.pic*self.speed > 0:
                            self.image.blit(self.total_image,(150-self.rect.width,-18),self.rect)
                            self.rect.topleft = (self.startrect.x-150,self.startrect.y) ###
                            self.mask = pygame.mask.from_surface(self.image)   ### 
                        else:
                            self.rect.width -= self.speed
                            self.done    = True
                    else: self.done    = True
                    
                elif self.direction == "back":
                    if self.startrect.y >= 50:
                        self.rect = pygame.Rect(0,0,50,self.pic*self.speed)
                        if self.startrect.y - self.pic*self.speed > 0:
                            self.image.blit(pygame.transform.rotate(self.total_image,90),(0,150-self.rect.height),self.rect)
                            self.rect.topleft = (self.startrect.x,self.startrect.y-150) ###
                            self.mask = pygame.mask.from_surface(self.image)   ###
                        else:
                            self.rect.height -= self.speed
                            self.done    = True
                    else: self.done    = True
                    
                elif self.direction == "front":
                    if self.startrect.y < 650:
                        self.rect = pygame.Rect(0,0,50,self.pic*self.speed)
                        if self.startrect.bottom+self.pic*self.speed < 700:
                            self.image.blit(pygame.transform.rotate(self.total_image,-90),(0,0),(self.rect.x,150-self.rect.height,50,self.rect.height))#self.rect)
                            self.rect.topleft = (self.startrect.x,self.startrect.bottom) ###
                            self.mask = pygame.mask.from_surface(self.image)   ###
                        else:
                            self.rect.height -= self.speed
                            self.done    = True
                    else:
                        self.done    = True
                self.pic += 1
        else:
            self.done = True


class Turret_Blast(Projectile):
    def __init__(self,angle,startrect):
        Projectile.__init__(self,angle,startrect) ###
        self.angle  = angle
        self.target = globs.Player.rect.center
        self.startrectcenter   = startrect.center
        self.speed  = 3
        self.atk    = 1

        self.imageraw = pygame.Surface((150,150)).convert()
        self.imageraw.blit(graphic["shootsheet"],(0,0),(150,50,150,150))
        self.imageraw.set_colorkey((255,0,255))
        self.image = pygame.transform.rotate(self.imageraw,-self.angle)

        self.imageraw = pygame.Surface((150,150)).convert()
        self.imageraw.blit(graphic["shootsheet"],(0,0),(300,50,150,150))
        self.imageraw.set_colorkey((255,0,255))

        self.will_spload = True
        self.spload_image = pygame.transform.rotate(self.imageraw,-self.angle)
        self.sploadtime = 0.0
        self.spload = False

        self.mask = pygame.mask.from_surface(self.image)

        self.rect = self.image.get_rect()
        self.rect.center = self.startrectcenter

        self.fatmask = pygame.Mask((self.rect.width,self.rect.height))
        self.fatmask.fill()

        self.get_riseandrun()
        self.nexty = self.ystep
        self.nextx = self.xstep

    def get_riseandrun(self):
            #get rise and run increments such that the rate of fire is constant in the direction fired
            xdiff = abs(globs.Player.rect.centerx - self.startrect.centerx)
            ydiff = abs(globs.Player.rect.centery - self.startrect.centery)
            if xdiff != 0:
                self.xstep = self.speed/(math.sqrt(1+(ydiff/xdiff)**2))
            else:
                self.xstep = 0
                self.ystep = self.speed
            if ydiff != 0:
                self.ystep = self.speed/(math.sqrt(1+(xdiff/ydiff)**2))
            else:
                self.ystep = 0
                self.xstep = self.speed

    def image_change(self): pass

    def left_map(self):
        #delete the projectile if it leaves the map
        if self.rect.centerx < 0 or self.rect.centerx > 1000:
            self.done = True
        elif self.rect.centery < 0 or self.rect.centery > 700:
            self.done = True                   
    
    def update(self):
        self.image_change()
        globs.Surface.blit(self.image,self.rect)
        self.update_logic()
        self.left_map()

        if abs(self.rect.centerx-self.startrectcenter[0]) > 25 or abs(self.rect.centery-self.startrectcenter[1]) > 25:
            if not self.done and globs.Level.solidmask.overlap_area(self.mask, (self.rect.topleft))!= 0:
                    self.done = True
                    
        if self.done == True:
            if self.will_spload:
                if not self.spload:
                    self.image = self.spload_image
                    self.spload = True
                    self.sploadtime = pygame.time.get_ticks()
                elif pygame.time.get_ticks() - self.sploadtime > 100:                
                    globs.Level.objects["projectiles"].remove(self)
            else:
                globs.Level.objects["projectiles"].remove(self)

    def update_logic(self):
        if not self.done:
            if self.target[0] > self.startrectcenter[0]:
                if self.nextx >= 1:
                    self.rect.centerx += self.nextx - (self.nextx%1)
                    self.nextx = self.xstep + (self.nextx%1)
                else:
                    self.nextx += self.xstep
            else:
                if self.nextx >= 1:
                    self.rect.centerx -= self.nextx - (self.nextx%1)
                    self.nextx = self.xstep + (self.nextx%1)
                else:
                    self.nextx += self.xstep
                    
            if self.target[1] > self.startrectcenter[1]:
                if self.nexty >= 1:
                    self.rect.centery += self.nexty - (self.nexty%1)
                    self.nexty = self.ystep + (self.nexty%1)
                else:
                    self.nexty += self.ystep
            else:
                if self.nexty >= 1:
                    self.rect.centery -= self.nexty - (self.nexty%1)
                    self.nexty = self.ystep + (self.nexty%1)
                else:
                    self.nexty += self.ystep
    
    def player_collission(self):
        self.done = True
        def collision_differential():
            #calculates a differential for the colliding rectangles in the x and y axis to determine from what direction
            #a player is hit
            dx = (globs.Player.fatmask.overlap_area(self.fatmask,(-globs.Player.rect.x+self.rect.x+1,-globs.Player.rect.y+self.rect.y)) -
                  globs.Player.fatmask.overlap_area(self.fatmask,(-globs.Player.rect.x+self.rect.x-1,-globs.Player.rect.y+self.rect.y)))
##            print(globs.Player.fatmask.overlap_area(self.fatmask,(-globs.Player.rect.x+self.rect.x+1,-globs.Player.rect.y+self.rect.y)))
##            print(globs.Player.fatmask.overlap_area(self.fatmask,(-globs.Player.rect.x+self.rect.x-1,-globs.Player.rect.y+self.rect.y)))
            dy = (globs.Player.fatmask.overlap_area(self.fatmask,(-globs.Player.rect.x+self.rect.x,-globs.Player.rect.y+self.rect.y+1)) -
                  globs.Player.fatmask.overlap_area(self.fatmask,(-globs.Player.rect.x+self.rect.x,-globs.Player.rect.y+self.rect.y-1)))
##            print(globs.Player.fatmask.overlap_area(self.fatmask,(-globs.Player.rect.x+self.rect.x,-globs.Player.rect.y+self.rect.y+1)))
##            print(globs.Player.fatmask.overlap_area(self.fatmask,(-globs.Player.rect.x+self.rect.x,-globs.Player.rect.y+self.rect.y-1)))
    
            if abs(dx) > abs(dy):
                if dx > 0: knock = (1,0);  #print ("knocked right")
                else     : knock = (-1,0); #print ("knocked left")
            else:
                if dy > 0: knock = (0,1);  #print ("knocked down")
                else     : knock = (0,-1); #print ("knocked up, and he didn't even buy me dinner")

##            print(dx,dy,knock)
##            print("Player",globs.Player.rect)
##            print("projectile",self.rect)
            return knock
        
        if pygame.time.get_ticks()-globs.Player.invincible_timer > 1000:
            #damage is reduced by defense but currently can not be reduced below 1
            if self.atk - globs.Player.defense > 1:
                globs.Player.health -= (self.atk - globs.Player.defense)
            else:
                globs.Player.health -= 1
            globs.Player.knockback = True
            globs.Player.knockdir  = collision_differential()
            globs.Player.invincible_timer = pygame.time.get_ticks()
        if globs.Player.health <= 0: globs.Player.dead = True

class BlueFlame(Turret_Blast):
    def __init__(self,angle,startrect):
        Projectile.__init__(self,angle,startrect) ###
        self.angle  = angle
        self.target = globs.Player.rect.center
        self.startrectcenter   = startrect.center
        self.speed  = 3
        self.atk    = 1

        self.will_spload = False

        self.framechoords = [(0,5),(1,5)]
        self.frames       = self.getframes(graphic["shootsheet"])
        for cell in self.frames:
            self.frames[cell] = self.frames[cell].convert()
            self.frames[cell].set_colorkey((255,0,255))
        self.mask         = pygame.mask.from_surface(self.frames[0])
        
        self.image        = self.frames[0]

        self.rect = self.image.get_rect()
        self.rect.center = self.startrectcenter

        self.fatmask = pygame.Mask((self.rect.width,self.rect.height))
        self.fatmask.fill()

        self.get_riseandrun()
        self.nexty = self.ystep
        self.nextx = self.xstep

    def get_riseandrun(self):
        if self.angle == None:
            Turret_Blast.get_riseandrun(self)
        else:
            self.xstep = (self.speed*math.cos(self.angle))
            self.ystep = (self.speed*math.sin(self.angle))


    def update_logic(self):
        if self.angle == None:
            Turret_Blast.update_logic(self)
        else:
            if not self.done:
                if abs(self.nextx) >= 1:
                    self.rect.centerx += self.nextx - (self.nextx%1)
                    self.nextx = self.xstep + (self.nextx%1)
                else:
                    self.nextx += self.xstep
                if abs(self.nexty) >= 1:
                    self.rect.centery += self.nexty - (self.nexty%1)
                    self.nexty = self.ystep + (self.nexty%1)
                else:
                    self.nexty += self.ystep
            
    def image_change(self):
        if pygame.time.get_ticks() - self.lastupdated > 1000/10:
                if self.frame == 0:
                    self.image = self.frames[self.frame]
                    self.frame = 1
                else:
                    self.image = self.frames[self.frame]
                    self.frame = 0
                self.lastupdated = pygame.time.get_ticks()   

        
        
        

        




        
